<?php 
############################################################
#                                                          #
# ██████ ██████ ██   ██ ██████  ████  █████   ████   ████  #
# █ ██ █ ██     ██   ██ █ ██ █ ██  ██ ██  ██   ██   ██  ██ #
#   ██   ██      ██ ██    ██   ██  ██ ██  ██   ██   ██     #
#   ██   █████    ███     ██   ██  ██ █████    ██   ██     #
#   ██   ██      ██ ██    ██   ██  ██ ██       ██   ██     #
#   ██   ██     ██   ██   ██   ██  ██ ██       ██   ██  ██ #
#  ████  ██████ ██   ██  ████   ████  ██      ████   ████  #
#                                                          #
############################################################
# base on fancytation api

########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################

define('FONTE_DEFAUT','oldnewspaper');
define('TAILLE_DEFAUT',32);
define('COULEUR_DEFAUT','000000');
define('VERSION','1.2');
include('zip_class.php');

##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
function file_curl_contents($url){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,  FALSE);     
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);     
	curl_setopt($ch, CURLOPT_URL, $url);     
	if (!ini_get("safe_mode") && !ini_get('open_basedir') ) {curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);}    
	curl_setopt($ch, CURLOPT_MAXREDIRS, 10); 
	curl_setopt($ch, CURLOPT_REFERER, 'http://oudanstoncul.free.fr');// notez le referer "custom"
	$data = curl_exec($ch);     
	curl_close($ch);     
	return $data; 
} 
function separatRGB($color){
    $color=str_replace('#','',$color);
    if (strlen($color)==3){
        $color=$color[0].$color[0].$color[1].$color[1].$color[2].$color[2];
    }
    $RGB=array();
    $RGB['r']=hexdec(substr($color, 0,2));
    $RGB['g']=hexdec(substr($color, 2,2));
    $RGB['b']=hexdec(substr($color, 4,2));  
    return $RGB;
}
function normalizeColor($str){
	$color=preg_replace('#[^0-9A-Fa-f]#','',$str);
	$nb=strlen($color);
    if ($nb==3){
        $color=$color[0].$color[0].$color[1].$color[1].$color[2].$color[2];
    }elseif($nb>6){
    	$color=substr($color, 0,6);
    }elseif($nb<3){
    	$color.=str_repeat('0', 3-$nb);
    }
    return $color;
}
function zipme($file,$exclude='*\.zip'){
    if (is_file($file)){
        header("Location: ".$file);
        exit;
    }
    $zip=new zip(); 
    $zip->listFiles('./',$exclude);    
    $zip->create('./',$file);
    $zip->download();
    exit;
}
########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}
if (isset($_GET['download'])){	
	zipme('Textopic_v'.VERSION.'.zip','.\.zip|.rendered\/.');
}
if (isset($_GET['fontslist'])){
	$fontlist=glob('fonts/*.ttf');
	$fontlist=array_map('basename',$fontlist);
	exit(json_encode($fontlist));
}
if (isset($_GET['picslist'])){
	$picslist=glob('rendered/*');
	if (!isset($_GET['random'])){
		$picslist=array_map('basename',$picslist);		
	}else{
		shuffle($picslist);
		$_GET['random']=intval($_GET['random']);
		if (empty($_GET['random'])){
			exit($picslist[0]);
		}
		$picslist=array_slice($picslist,0, $_GET['random']);
	}
	if (!isset($_GET['gallery'])){
		exit(json_encode($picslist));
	}else{
		echo '<style>img{display:block;width:100%;height:auto;}</style><div style="display:grid;grid-template-columns: repeat(auto-fit, minmax(256px, 1fr));
			">';
		foreach ($picslist as $pic) {
			echo '<img src="rendered/'.$pic.'"/>';
		}
		echo '</div>';
	}
	
}

if (!empty($_GET['t'])){

	$filename=hash('sha1', $_SERVER['QUERY_STRING']).'.jpg';
	$generated_picture_path='rendered/'.$filename;
	# ne pas régénérer les images déjà générées
	if (is_file($generated_picture_path) && !isset($_GET['force'])){
		header ("Content-type: image/jpg");
		exit(file_get_contents($generated_picture_path));
	}

	$fs=!empty($_GET['fs'])?filter_var($_GET['fs'],FILTER_SANITIZE_NUMBER_INT):TAILLE_DEFAUT;
	$c=!empty($_GET['c'])?filter_var($_GET['c'],FILTER_SANITIZE_STRING):COULEUR_DEFAUT;
	$vertical=isset($_GET['vertical']);
	$t=!empty($_GET['t'])?filter_var($_GET['t'],FILTER_SANITIZE_STRING):'Il pellentesque eget elementum gravida ut in in et. sagittis Maecenas ultricies, in Ipsum';
	$f=!empty($_GET['f'])?filter_var($_GET['f'],FILTER_SANITIZE_STRING):FONTE_DEFAUT;

	$t=str_replace('\n',"\n", $t);

		
	$fontfile=glob('fonts/*'.$f.'*.ttf')[0];
	
	$textbox=imagettfbbox($fs, 0, $fontfile, $t);
	$texte_y=abs($textbox[5]);
	$texte_x=abs($textbox[6]);
	$texte_w=abs($textbox[2])+$texte_x;//+(2*$fs);
	$texte_h=abs($textbox[3])+$texte_y;

	$generated_picture = @imagecreatetruecolor($texte_w, $texte_h) or die ("Erreur lors de la création de l'image");

	# colors
	$c=separatRGB($c);
	if ($c['r']+$c['g']+$c['b']>382){
		$background_color=imagecolorallocate( $generated_picture , 0,0,0);
	}else{
		$background_color=imagecolorallocate( $generated_picture , 255,255,255);
	}
	$color=imagecolorallocate ( $generated_picture , $c['r'] ,$c['g'] , $c['b']);
	imagefill($generated_picture, 1,1, $background_color);

	# text
	imagettftext($generated_picture,$fs,0,$texte_x,$texte_y,$color,$fontfile,$t);
	if ($vertical!=false){
		$generated_picture=imagerotate($generated_picture, 270, $background_color);
	}

	header ("Content-type: image/jpg");
	
	if (!isset($_GET['dontsave'])){
		
		imagejpeg($generated_picture,$generated_picture_path,100);
		exit(file_get_contents($generated_picture_path));
	}else{
		imagejpeg($generated_picture,null,100);
	}
	exit;
}
include('frontend.php');
