<?php 
######################################################
#                                                    #
# █     █ ██████ █     █  ████  ██████  ████   ████  #
# ██   ██ ██     ██   ██ ██  ██ █ ██ █   ██   ██  ██ #
# ███ ███ ██     ███ ███ ██  ██   ██     ██   ██     #
# ███████ █████  ███████ ██████   ██     ██   ██     #
# ██ █ ██ ██     ██ █ ██ ██  ██   ██     ██   ██     #
# ██   ██ ██     ██   ██ ██  ██   ██     ██   ██  ██ #
# ██   ██ ██████ ██   ██ ██  ██  ████   ████   ████  #
#                                                    #
######################################################

########################
#                      #
#  ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#   ▒▒   ▒▒▒ ▒▒   ▒▒   #
#   ▒▒   ▒▒▒▒▒▒   ▒▒   #
#   ▒▒   ▒▒ ▒▒▒   ▒▒   #
#   ▒▒   ▒▒  ▒▒   ▒▒   #
#  ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                      #
########################
define('LARGEUR_PARAGRAPHE',50);# en nb de caractères
define('POLICE','fonts/oldnewspaper.ttf');
define('LARGEUR_DEFAUT',800); // px
define('VERSION','1.67');# changement vers imagecreatefromstring

##################################################################
#                                                                #
# ▒▒▒▒▒▒ ▒▒  ▒▒ ▒   ▒▒  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒   ▒▒▒▒  ▒   ▒▒  ▒▒▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ ▒ ▒▒ ▒   ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒     ▒▒  ▒▒ ▒▒▒ ▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒ ▒▒  ▒▒    #
# ▒▒▒▒▒  ▒▒  ▒▒ ▒▒▒▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒▒▒▒▒   ▒▒   #
# ▒▒     ▒▒  ▒▒ ▒▒ ▒▒▒ ▒▒       ▒▒     ▒▒   ▒▒  ▒▒ ▒▒ ▒▒▒    ▒▒  #
# ▒▒     ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒   ▒▒     ▒▒   ▒▒  ▒▒ ▒▒  ▒▒ ▒▒  ▒▒ #
# ▒▒      ▒▒▒▒  ▒▒   ▒  ▒▒▒▒   ▒▒▒▒   ▒▒▒▒   ▒▒▒▒  ▒▒   ▒  ▒▒▒▒  #
#                                                                #
##################################################################
include('zip_class.php');
function zipme($file,$exclude='*\.zip'){
    if (is_file($file)){
        header("Location: ".$file);
        exit;
    }
    $zip=new zip(); 
    $zip->listFiles('./',$exclude); 
    $zip->create('./',$file);
    $zip->download();
    exit;
}
function file_curl_contents($url){
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,  FALSE);     
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);     
	curl_setopt($ch, CURLOPT_URL, $url);     
	if (!ini_get("safe_mode") && !ini_get('open_basedir') ) {curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);}    
	curl_setopt($ch, CURLOPT_MAXREDIRS, 10); 
	curl_setopt($ch, CURLOPT_REFERER, 'http://oudanstoncul.free.fr');// notez le referer "custom"
	$data = curl_exec($ch);     
	curl_close($ch);     
	return $data; 
} 
function newSize($blank_meme_w,$blank_meme_h){	
	$new_w=LARGEUR-(2*PADDING);
	$new_h=round(($blank_meme_h*$new_w)/$blank_meme_w);
	return ['w'=>$new_w,'h'=>$new_h];	
}

function separatRGB($color){
    $color=str_replace('#','',$color);
    if (strlen($color)==3){
        $color=$color[0].$color[0].$color[1].$color[1].$color[2].$color[2];
    }
    $RGB=array();
    $RGB['r']=hexdec(substr($color, 0,2));
    $RGB['g']=hexdec(substr($color, 2,2));
    $RGB['b']=hexdec(substr($color, 4,2));  
    return $RGB;
}
function normalizeColor($str){
	$color=preg_replace('#[^0-9A-Fa-f]#','',$str);
	$nb=strlen($color);
    if ($nb==3){
        $color=$color[0].$color[0].$color[1].$color[1].$color[2].$color[2];
    }elseif($nb>6){
    	$color=substr($color, 0,6);
    }elseif($nb<3){
    	$color.=str_repeat('0', 3-$nb);
    }
    return $color;
}
function getURL(){
    $url = @( $_SERVER["HTTPS"] != 'on' ) ? 'http://'.$_SERVER["SERVER_NAME"] : 'https://'.$_SERVER["SERVER_NAME"];
    $url .= dirname($_SERVER["SCRIPT_NAME"]);    
    return $url;
}    
########################
#                      #
#  ▒▒▒▒  ▒▒▒▒▒▒ ▒▒▒▒▒▒ #
# ▒▒  ▒▒ ▒▒     ▒ ▒▒ ▒ #
# ▒▒     ▒▒       ▒▒   #
# ▒▒ ▒▒▒ ▒▒▒▒▒    ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
# ▒▒  ▒▒ ▒▒       ▒▒   #
#  ▒▒▒▒  ▒▒▒▒▒▒  ▒▒▒▒  #
#                      #
########################

if (isset($_GET['help'])){	
	exit(nl2br(file_get_contents('readme.html')));
}

if (isset($_GET['version'])){	
	exit(VERSION);
}
if (isset($_GET['bookmarklet'])){	
	exit("Copier ce lien de bookmarklet: <a href=\"javascript:javascript:(function(){url=encodeURIComponent(location.href);window.open('".getURL()."/?i='+url,'mybookmarklet','');})();\">Mematic</a>");
}
if (isset($_GET['download'])){	
	zipme('Mematic_v'.VERSION.'.zip','.\.zip|.rendered.');
}

if (isset($_GET['picslist'])){
	$picslist=glob('rendered/*');
	if (!isset($_GET['random'])){
		$picslist=array_map('basename',$picslist);		
	}else{
		shuffle($picslist);
		$_GET['random']=intval($_GET['random']);
		if (empty($_GET['random'])){
			exit($picslist[0]);
		}
		$picslist=array_slice($picslist,0, $_GET['random']);
	}
	exit(json_encode($picslist));
}

if (isset($_GET['w'])&&filter_var($_GET['w'],FILTER_VALIDATE_INT)){
	define('LARGEUR',$_GET['w']);
	define('PADDING',LARGEUR*0.05);
}else{
	define('LARGEUR',LARGEUR_DEFAUT);
	define('PADDING',40);# px
}

if (isset($_GET['white'])){
	define('COULEUR_POLICE','000000');
	define('COULEUR_FOND','FFFFFF');
}else{
	define('COULEUR_FOND','000000');
	define('COULEUR_POLICE','FFFFFF');
}

$there_is_an_image_url=(!empty($_GET['i'])&&filter_var($_GET['i'],FILTER_VALIDATE_URL));

if ($there_is_an_image_url&&!empty($_GET['t'])){
	
	$filename=hash('sha1', $_SERVER['QUERY_STRING']).'.jpg';
	$generated_picture_path='rendered/'.$filename;
	# ne pas régénérer les images déjà générées
	if (is_file($generated_picture_path) && !isset($_GET['force'])){
		header ("Content-type: image/jpg");
		exit(file_get_contents($generated_picture_path));
	}

	$t=filter_var($_GET['t'],FILTER_SANITIZE_STRING);
	$t=str_replace('\n',"\n", $t);
	$t="\n\n".wordwrap($t,LARGEUR_PARAGRAPHE)."\n\n ";
	$url=filter_var($_GET['i'],FILTER_SANITIZE_URL);

	# download images to use them
	if ($downloaded_pic=file_curl_contents($url)){
		$image=imagecreatefromstring($downloaded_pic);
		list($blank_meme_w,$blank_meme_h) = getimagesizefromstring($downloaded_pic);
	}else{exit("Erreur de téléchargement de l'image");}
	


	# calcul de la taille de police
	$fs=round((LARGEUR-(PADDING*2))/LARGEUR_PARAGRAPHE)+8;
	# calcul de la taille de la textbox
	$textbox=imagettfbbox($fs, 0, POLICE, $t);
	$texte_w=$textbox[2];
	$texte_h=$textbox[3];

	# calcul de la taille de l'image finale (hauteur de l'image recalculée + hauteur de la boîte de texte)
	$new_size=newSize($blank_meme_w,$blank_meme_h);
	$generated_picture_h=PADDING+$new_size['h']+$texte_h;

	# création de l'image finale
	$generated_picture = @imagecreatetruecolor(LARGEUR, $generated_picture_h) or die ("Erreur lors de la création de l'image");

	# colors
	$c=separatRGB(COULEUR_FOND);
	$fond=imagecolorallocate ( $generated_picture , $c['r'] ,$c['g'] , $c['b']);
	$c=separatRGB(COULEUR_POLICE);
	$texte=imagecolorallocate ( $generated_picture , $c['r'] ,$c['g'] , $c['b']);

	# remplissage du fond
	imagefill($generated_picture, 0, 0, $fond);
	imagefilledrectangle($generated_picture, PADDING-2, PADDING-2, $new_size['w']+PADDING+2, $new_size['h']+PADDING+2, $texte);
	
	# Resize background texture
	$img_fond_originale  = imagecreatefromstring($downloaded_pic);
	$img_fond_redimensionnee = imagecreatetruecolor($new_size['w'],$new_size['h']);
	imagecopyresampled($img_fond_redimensionnee,$img_fond_originale,0,0,0,0,$new_size['w'],$new_size['h'],$blank_meme_w,$blank_meme_h);

	# crop to the textbox's dimensions
	imagecopy($generated_picture , $img_fond_redimensionnee , PADDING ,PADDING , 0,0 , $new_size['w'] , $new_size['h'] );

	# text
	imagettftext($generated_picture,$fs,0,PADDING,$new_size['h']+PADDING,$texte,POLICE,$t);
	//if (is_file($local_path_to_downloaded_pic)){unlink($local_path_to_downloaded_pic);}
//	if (error_get_last()){exit('');}

	header ("Content-type: image/jpg");
	if (!isset($_GET['dontsave'])){
		
		imagejpeg($generated_picture,$generated_picture_path,90);
		exit(file_get_contents($generated_picture_path));
	}else{
		imagejpeg($generated_picture,null,90);
		exit();
	}
	
	
}elseif($there_is_an_image_url){
	define('URL', filter_var($_GET['i'],FILTER_SANITIZE_URL));
}else{
	define('URL','');
}

include('frontend.php');
?>